#include <stdlib.h>
#include <stdio.h>

int main(int argc, char* argv[]) {
    // make a dynamically allocated 25x40 array of integers
    // we do this by making an array of 25 arrays, where each sub-array has 40 integers
    
    // allocate outer array
    int** a = (int**) malloc(25*sizeof(int*)); // array of int pointers
    
    // allocate all 25 sub-arrays
    for (int i=0; i<25; i++) { // << BUG IN THIS LINE
        a[i] = (int*) malloc(40*4); // enough space for 40 integers << BUG IN THIS LINE
    }
    
    // populate array so each cell has 100*ROW+COL
    for (int i=0; i<25; i++) {
        for (int j=0; j<40; j++) {
            a[i][j] = 100*i + j;
        }
    }
    
    // do some simple math; let's just sum the array
    int sum=0;
    for (int i=0; i<25; i++) {
        for (int j=0; j<40; j++) {
            sum += a[i][j];
        }
    }
    printf("Sum=%d\n",sum);



    // de-allocate the outer array
    free(a); // << BUG IN THE FACT THAT THIS LINE COMES BEFORE THE LOOP BELOW

    // de-allocate all 25 sub-arrays
    for (int i=0; i<20; i++) { // << BUG IN THIS LINE
        free(a[i]);
    }
    
    // vvvv  BUG HERE
    // totally needless additional bug: freeing memory that was uninitialized
    // (fix this bug by just deleting this part)
    int* p;
    free(p);
    
}